# BEGIN SourceDeps(oneline):
BuildRequires(pre): rpm-build-python
# END SourceDeps(oneline)
%define oldname python-mtTkinter
# see https://bugzilla.altlinux.org/show_bug.cgi?id=10382
%define _localstatedir %{_var}
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Summary:   A thread-safe version of Tkinter
Name:      python-module-mtTkinter
Version:   0.4
Release:   alt1_16
License:   LGPLv3+
Source0:   http://tkinter.unpythonic.net/attach/mtTkinter/attachments/mtTkinter-%{version}.tar.gz
Source1:   08-clock-bezier.py
Group:     Development/Other
URL:       http://tkinter.unpythonic.net/wiki/mtTkinter
BuildRequires: python-devel >= 2.4
BuildArch: noarch

%global _description\
Although Tkinter is technically thread-safe\
(assuming Tk is built with --enable-threads),\
practically speaking there are still problems when used in multithreaded\
Python applications.  The problems stem from the fact that the _tkinter\
module attempts to gain control of the main thread via a polling technique\
when processing calls from other threads.  If it succeeds, all is well.\
If it fails (i.e., after a timeout), the application receives an exception\
with the message: "RuntimeError: main thread is not in main loop".\
There is no way to tell when this might happen, so calling Tk routines\
from multiple threads seems to be problematic at best.\
\
The mtTkinter module solves this problem by modifying some Tkinter\
module definitions (in memory). The modified code intercepts\
out-of-thread Tkinter calls and marshals them through a queue which\
is read by an 'after' event running periodically in the main loop.\
This is similar to the technique used in many other platforms\
(e.g., .NET's InvokeRequired/Invoke mechanism).\
The technique used in mtTkinter is exception-safe as well,\
marshaling exceptions through a response queue back to the caller's thread.
Source44: import.info

%description %_description

%prep
%setup -q -n mtTkinter-%{version}

%build

%install

mkdir -p %{buildroot}%{python_sitelibdir_noarch}
install -pm 0644 %{_builddir}/mtTkinter-%{version}/mtTkinter.py %{buildroot}%{python_sitelibdir_noarch}/
install -pm 0644 %{SOURCE1} %{_builddir}/mtTkinter-%{version}/clock-bezier.py

%files -n python-module-mtTkinter
%doc clock-bezier.py lgpl.txt gpl.txt
%{python_sitelibdir_noarch}/mtTkinter.py*

%changelog
* Tue Feb 20 2018 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_16
- update to new release by fcimport

* Mon Oct 09 2017 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_14
- update to new release by fcimport

* Wed Mar 15 2017 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_12
- update to new release by fcimport

* Fri Sep 30 2016 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_11
- update to new release by fcimport

* Wed Mar 02 2016 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_10
- update to new release by fcimport

* Mon Oct 19 2015 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_9
- update to new release by fcimport

* Mon Jul 07 2014 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_8
- update to new release by fcimport

* Mon Sep 02 2013 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_7
- update to new release by fcimport

* Thu Feb 21 2013 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_6
- update to new release by fcimport

* Sun Dec 30 2012 Igor Vlasenko <viy@altlinux.ru> 0.4-alt1_5
- initial fc import

